//+------------------------------------------------------------------+
//|                                                VelocityWaves.mq4 |
//|                               Copyright c 2010, Vladimir Hlystov |
//|                                         http://cmillion.narod.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright c 2010, Vladimir Hlystov"
#property link      "http://cmillion.narod.ru"
//+------------------------------------------------------------------+
 
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Blue
extern bool DrawVisualization1 = true;
//---- indicator ZIGZAG parameters
extern int Zigzag_Depth1    = 12;
extern int Zigzag_Deviation1= 5;
extern int Zigzag_Backstep1 = 3;

extern string Currency1 = "EURUSD";//"USDCAD" ;//                "XAUUSD"
//----
extern color WavesColor1    = Gray;
extern color TrendUpColor1  = Yellow;//Red;
extern color TrendDnColor1  = Green;//Blue;
extern int   TotalTrend1    = 10;

extern bool Mirroring1 = false;


int Grid1 = 10; //Grid Lines
int SnapPips1 = 10;  //Snap Pips For Grid Lines

//---- indicator buffers
double HighMapBuffer1[];
double LowMapBuffer1[];
double Waves1[101][2];
//+------------------------------------------------------------------+
int init()
  {
   if (TotalTrend1>98) TotalTrend1=98;
   IndicatorBuffers(1);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,HighMapBuffer1);
   SetIndexBuffer(1,LowMapBuffer1);
   SetIndexEmptyValue(0,0.0);
   IndicatorShortName("VelocityWaves("+Zigzag_Depth1+","+Zigzag_Deviation1+","+Zigzag_Backstep1+")");
   return(0);
  }
//+------------------------------------------------------------------+
int start()
  {
   //double shift_Y = (WindowPriceMax()-WindowPriceMin()) / 45;
   double ZigzagBuffer1,H_Wave1,S_Wave1,V_olum1,
          v_tek_trend,s_tek_trend=0,h_tek_trend;
   int n,T_Wave1,k1,k11,max_bulls_trend,max_bears_trend=1000000,max_bulls,max_bears,
       t_tek_trend;
   string txt1,rec1;
   
   double point;
   
   int i=0;
   
   
 //===============================================  
   
   int _BarsCount1;
   double _CurRangeHigh1, _CurRangeLow1, _CurRangeCenter1;
   double _SubRangeHigh1, _SubRangeLow1, _SubRangeCenter1;
   double _SubPoint1, _SubDigit1;
   double _SubOpen1, _SubHigh1, _SubLow1, _SubClose1;
   double _PipsRatio1;
   double _GridPips1, _GridPrice1;
   
   
 //===============================================  
 //---------------------------------------------------------------------------------------------------  
   while (true)
   {
      if (n==TotalTrend1+2) break;
      ZigzagBuffer1=iCustom(Currency1, 0, "ZigZag",Zigzag_Depth1,Zigzag_Deviation1,Zigzag_Backstep1,0,i);
      if (ZigzagBuffer1!=0) 
      {
         Waves1[n][0]=ZigzagBuffer1;
         Waves1[n][1]=i;
         
       //  Alert("Waves== ", Waves[n][0]);
         
         n++;
         
      }
      i++;
   }
 //===================================================================  
   
   //Calculate Visible Bars
   _BarsCount1 = BarsPerWindow() + 1;
   int _FirstBar1 = FirstVisibleBar();
   int _LastBar1 = _FirstBar1 - _BarsCount1 + 1;
   if ( _LastBar1 < 0 ) 
   {
      _LastBar1 = 0;
      _BarsCount1 = _FirstBar1 + 1;
   }
   
 //===================================================================  
   
   _CurRangeHigh1 = High[Highest(NULL, 0, MODE_HIGH, _BarsCount1, _LastBar1)];
   _CurRangeLow1 = Low[Lowest(NULL, 0, MODE_LOW, _BarsCount1, _LastBar1)];
   _CurRangeCenter1 = ( _CurRangeHigh1 + _CurRangeLow1 ) / 2;

   if ( Mirroring1 ) 
   {
      _SubRangeHigh1 = iLow( Currency1, 0, Lowest( Currency1, 0, MODE_LOW, _BarsCount1, _LastBar1 ) );
      _SubRangeLow1 = iHigh( Currency1, 0, Highest( Currency1, 0, MODE_HIGH, _BarsCount1, _LastBar1 ) );
   } else 
   {
      _SubRangeHigh1 = iHigh( Currency1, 0, Highest( Currency1, 0, MODE_HIGH, _BarsCount1, _LastBar1 ) );
      _SubRangeLow1 = iLow( Currency1, 0, Lowest( Currency1, 0, MODE_LOW, _BarsCount1, _LastBar1 ) );
   }

   _SubRangeCenter1 = ( _SubRangeHigh1 + _SubRangeLow1 ) / 2;//2
   _SubPoint1 = MarketInfo( Currency1, MODE_POINT );
   _SubDigit1 = MarketInfo( Currency1, MODE_DIGITS );

   _PipsRatio1 = ( _CurRangeHigh1 - _CurRangeLow1 )  / ( _SubRangeHigh1 - _SubRangeLow1 );

   _GridPips1 = ( _SubRangeHigh1 - _SubRangeLow1 ) / Grid1;
   _GridPips1 = MathRound( ( _SubRangeHigh1 - _SubRangeLow1 ) / Grid1 / ( _SubPoint1 * SnapPips1 ) ) * ( _SubPoint1 * SnapPips1 );
   
   
   
 //===================================================================  
 //--------------------------------------  
   point =MarketInfo(Currency1,MODE_POINT);
 //---------------------------------------------------------------------------------------------------  
   for (i=n-2; i>=0; i--)
   {
    //  T_Wave=(Waves[i+1][1]-Waves[i][1])*Period()/60;
      H_Wave1=(Waves1[i][0]-Waves1[i+1][0])/point;   //  Point
      
  //    Alert("H_WAves== ", H_Wave);    -   
     
     
      if (T_Wave1!=0) S_Wave1=H_Wave1/T_Wave1;
      V_olum1=SrVolume(Waves1[i+1][1],Waves1[i][1]);
      if (max_bulls_trend<H_Wave1) 
      {
         max_bulls_trend=H_Wave1;
         max_bulls=i;
      }
      if (max_bears_trend>H_Wave1) 
      {
         max_bears_trend=H_Wave1;
         max_bears=i;
      }
      
      
      k1=Waves1[i][1]; //k
      k11=Waves1[i+1][1];  //k1
      
   //   Alert("k== ", k, "  k1== ", k1);
      
      
      if (DrawVisualization1)//     true
      {
         txt1=StringConcatenate("info1  ",i);
         rec1=StringConcatenate("trend1 ",i);
         ObjectDelete(txt1);
         ObjectDelete(rec1);
         ObjectCreate(rec1, OBJ_RECTANGLE, 0, Time[k11],(Waves1[i+1][0])* _PipsRatio1, Time[k1],(Waves1[i][0])* _PipsRatio1);//* _PipsRatio1
         
         if (H_Wave1>0) 
         {
            ObjectSet   (rec1, OBJPROP_COLOR, TrendUpColor1);
         }
         else          
         {
            ObjectSet   (rec1, OBJPROP_COLOR, TrendDnColor1);
         }
         
        /* 
         ObjectCreate (txt1, OBJ_TEXT,0,Time[k11]+(Time[k1]-Time[k11])/2,(Waves1[i][0])* _PipsRatio1,0,0,0,0);
         ObjectSetText(txt1, StringConcatenate(" h",H_Wave1,
                                              " v",DoubleToStr(V_olum1,2),
                                              " s",DoubleToStr(S_Wave1,2)
                                              ),8,"Arial");
         ObjectSet   (txt1, OBJPROP_COLOR, WavesColor1);
         ObjectSet   (rec1, OBJPROP_STYLE, STYLE_DOT);
         ObjectSet   (rec1, OBJPROP_WIDTH,1);
         ObjectSet   (rec1, OBJPROP_BACK, true);
        */ 
      }
   }
   string name;
   
   /*
   int nullbar=Waves[1][1];
   //t_tek_trend=(TimeCurrent()-Time[nullbar])/60;//*Period();
   t_tek_trend=Waves[1][1]*Period()/60;
   if (Waves[1][0]!=0) h_tek_trend=(Bid-Waves[1][0])/Point; else h_tek_trend=0;
   v_tek_trend=SrVolume(Waves[1][1],0);
   if (t_tek_trend!=0) s_tek_trend=h_tek_trend/(t_tek_trend); else s_tek_trend = 0;
   Comment("h ",DoubleToStr(h_tek_trend,0),
        "   v ",DoubleToStr(v_tek_trend,2),
        "   s ",DoubleToStr(s_tek_trend,2));
   */   
        
        
return (0);// 
}
//+------------------------------------------------------------------+
/*
int deinit()
{
   ObjectsDeleteAll(0,OBJ_TEXT);
   ObjectsDeleteAll(0,OBJ_RECTANGLE);
   return(0);
}
*/
//+------------------------------------------------------------------+
double SrVolume(int start,int end)
{
   double Vol;
   for (int i=start+1; i>=end; i--)
   {
      Vol=Vol+Volume[i];
   }
   if (start!=end) Vol=Vol/(start-end);
   return(Vol);
}
//+------------------------------------------------------------------+